Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import nat.
Parameter mod_aux : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Parameter mod_aux_body : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Axiom axiom_mod_aux : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (mod_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) mod_aux_body p).
Definition eq_mod_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (mod_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) mod_aux_body p) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) mod_aux_body p)) ((axiom_mod_aux) (p)).
Definition sym_eq_mod_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) mod_aux_body p) (mod_aux p) := fun (p:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) mod_aux_body p)) ((eq_mod_aux) (p)).
Axiom axiom_mod_aux_body_O : connectives.equal (nat.nat -> nat.nat -> nat.nat) (mod_aux_body nat.O) (fun (m:nat.nat) => fun (n:nat.nat) => m).
Definition eq_mod_aux_body_O : leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (mod_aux_body nat.O) (fun (m:nat.nat) => fun (n:nat.nat) => m) := ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body nat.O)) (fun (m:nat.nat) => fun (n:nat.nat) => m)) (axiom_mod_aux_body_O).
Definition sym_eq_mod_aux_body_O : leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (fun (m:nat.nat) => fun (n:nat.nat) => m) (mod_aux_body nat.O) := ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body nat.O)) (fun (m:nat.nat) => fun (n:nat.nat) => m)) (eq_mod_aux_body_O).
Axiom axiom_mod_aux_body_S : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (mod_aux_body (nat.S p)) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) m (mod_aux p (nat.minus m (nat.S n)) n) (nat.leb m n)).
Definition eq_mod_aux_body_S : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (mod_aux_body (nat.S p)) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) m (mod_aux p (nat.minus m (nat.S n)) n) (nat.leb m n)) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body (nat.S p))) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) m (mod_aux p (nat.minus m (nat.S n)) n) (nat.leb m n))) ((axiom_mod_aux_body_S) (p)).
Definition sym_eq_mod_aux_body_S : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) m (mod_aux p (nat.minus m (nat.S n)) n) (nat.leb m n)) (mod_aux_body (nat.S p)) := fun (p:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body (nat.S p))) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) m (mod_aux p (nat.minus m (nat.S n)) n) (nat.leb m n))) ((eq_mod_aux_body_S) (p)).
Definition mod : nat.nat -> nat.nat -> nat.nat := fun (n:nat.nat) => fun (m:nat.nat) => nat.match_nat_type (nat.nat) n (fun (p:nat.nat) => mod_aux n n p) m.
Parameter div_aux : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Parameter div_aux_body : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Axiom axiom_div_aux : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (div_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) div_aux_body p).
Definition eq_div_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (div_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) div_aux_body p) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (div_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) div_aux_body p)) ((axiom_div_aux) (p)).
Definition sym_eq_div_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) div_aux_body p) (div_aux p) := fun (p:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (div_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) div_aux_body p)) ((eq_div_aux) (p)).
Axiom axiom_div_aux_body_O : connectives.equal (nat.nat -> nat.nat -> nat.nat) (div_aux_body nat.O) (fun (m:nat.nat) => fun (n:nat.nat) => nat.O).
Definition eq_div_aux_body_O : leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (div_aux_body nat.O) (fun (m:nat.nat) => fun (n:nat.nat) => nat.O) := ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (div_aux_body nat.O)) (fun (m:nat.nat) => fun (n:nat.nat) => nat.O)) (axiom_div_aux_body_O).
Definition sym_eq_div_aux_body_O : leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (fun (m:nat.nat) => fun (n:nat.nat) => nat.O) (div_aux_body nat.O) := ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (div_aux_body nat.O)) (fun (m:nat.nat) => fun (n:nat.nat) => nat.O)) (eq_div_aux_body_O).
Axiom axiom_div_aux_body_S : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (div_aux_body (nat.S p)) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux p (nat.minus m (nat.S n)) n)) (nat.leb m n)).
Definition eq_div_aux_body_S : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (div_aux_body (nat.S p)) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux p (nat.minus m (nat.S n)) n)) (nat.leb m n)) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (div_aux_body (nat.S p))) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux p (nat.minus m (nat.S n)) n)) (nat.leb m n))) ((axiom_div_aux_body_S) (p)).
Definition sym_eq_div_aux_body_S : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux p (nat.minus m (nat.S n)) n)) (nat.leb m n)) (div_aux_body (nat.S p)) := fun (p:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (div_aux_body (nat.S p))) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux p (nat.minus m (nat.S n)) n)) (nat.leb m n))) ((eq_div_aux_body_S) (p)).
Definition div : nat.nat -> nat.nat -> nat.nat := fun (n:nat.nat) => fun (m:nat.nat) => nat.match_nat_type (nat.nat) (nat.S n) (fun (p:nat.nat) => div_aux n n p) m.
Definition div_aux_mod_aux : forall (p:nat.nat), forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) n (nat.plus (nat.times (div_aux p n m) (nat.S m)) (mod_aux p n m)) := fun (p:nat.nat) => ((((nat.nat_ind) (fun (_x_365:nat.nat) => forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) n (nat.plus (nat.times (div_aux _x_365 n m) (nat.S m)) (mod_aux _x_365 n m)))) (fun (n:nat.nat) => fun (m:nat.nat) => (((sym_eq_div_aux) (nat.O)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (nat.times (y n m) (nat.S m)) (mod_aux nat.O n m)))) (((((nat.sym_eq_filter_nat_type_O) (nat.nat -> nat.nat -> nat.nat)) (div_aux_body)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (nat.times (y n m) (nat.S m)) (mod_aux nat.O n m)))) (((sym_eq_div_aux_body_O) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (nat.times (y n m) (nat.S m)) (mod_aux nat.O n m)))) ((((((nat.eq_match_nat_type_O) (nat.nat)) (nat.O)) (fun (q:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q (nat.minus n (nat.S m)) m)) (nat.leb n m))) (fun (y:nat.nat) => logic.eq (nat.nat) n (nat.plus (nat.times y (nat.S m)) (mod_aux nat.O n m)))) ((((sym_eq_mod_aux) (nat.O)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (nat.times (((fun (m0:nat.nat) => fun (n0:nat.nat) => nat.match_nat_type (nat.nat) nat.O (fun (q:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q (nat.minus m0 (nat.S n0)) n0)) (nat.leb m0 n0)) nat.O) n) m) (nat.S m)) (y n m)))) (((((nat.sym_eq_filter_nat_type_O) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (nat.times (((fun (m0:nat.nat) => fun (n0:nat.nat) => nat.match_nat_type (nat.nat) nat.O (fun (q:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q (nat.minus m0 (nat.S n0)) n0)) (nat.leb m0 n0)) nat.O) n) m) (nat.S m)) (y n m)))) (((sym_eq_mod_aux_body_O) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (nat.times (((fun (m0:nat.nat) => fun (n0:nat.nat) => nat.match_nat_type (nat.nat) nat.O (fun (q:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q (nat.minus m0 (nat.S n0)) n0)) (nat.leb m0 n0)) nat.O) n) m) (nat.S m)) (y n m)))) ((((((nat.sym_eq_match_nat_type_O) (nat.nat)) (nat.O)) (fun (q:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q (nat.minus n (nat.S m)) m)) (nat.leb n m))) (fun (y:nat.nat) => logic.eq (nat.nat) n (nat.plus (nat.times (((fun (m0:nat.nat) => fun (n0:nat.nat) => y) n) m) (nat.S m)) n))) ((((nat.sym_eq_times) (nat.O)) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (y (nat.S m)) n))) (((((nat.sym_eq_filter_nat_type_O) (nat.nat -> nat.nat)) (nat.times_body)) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (y (nat.S m)) n))) (((nat.sym_eq_times_body_O) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (y (nat.S m)) n))) ((((nat.sym_eq_plus) (nat.O)) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (y n))) (((((nat.sym_eq_filter_nat_type_O) (nat.nat -> nat.nat)) (nat.plus_body)) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (y n))) (((nat.sym_eq_plus_body_O) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (y n))) (((logic.refl) (nat.nat)) (n))))))))))))))))) (fun (q:nat.nat) => (((sym_eq_div_aux) (nat.S q)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) n (nat.plus (nat.times (div_aux q n m) (nat.S m)) (mod_aux q n m))) -> forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) n (nat.plus (nat.times (y n m) (nat.S m)) (mod_aux (nat.S q) n m)))) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat -> nat.nat)) (div_aux_body)) (q)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) n (nat.plus (nat.times (div_aux q n m) (nat.S m)) (mod_aux q n m))) -> forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) n (nat.plus (nat.times (y n m) (nat.S m)) (mod_aux (nat.S q) n m)))) ((((sym_eq_div_aux_body_S) (q)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) n (nat.plus (nat.times (div_aux q n m) (nat.S m)) (mod_aux q n m))) -> forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) n (nat.plus (nat.times (y n m) (nat.S m)) (mod_aux (nat.S q) n m)))) (fun (Hind:forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) n (nat.plus (nat.times (div_aux q n m) (nat.S m)) (mod_aux q n m))) => (fun (n:nat.nat) => fun (m:nat.nat) => ((((((nat.eq_match_nat_type_S) (nat.nat)) (nat.O)) (fun (q0:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q0 (nat.minus n (nat.S m)) m)) (nat.leb n m))) (q)) (fun (y:nat.nat) => logic.eq (nat.nat) n (nat.plus (nat.times y (nat.S m)) (mod_aux (nat.S q) n m)))) ((((sym_eq_mod_aux) (nat.S q)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (nat.times (((fun (m0:nat.nat) => fun (n0:nat.nat) => nat.match_nat_type (nat.nat) nat.O (fun (q0:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q0 (nat.minus m0 (nat.S n0)) n0)) (nat.leb m0 n0)) (nat.S q)) n) m) (nat.S m)) (y n m)))) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat -> nat.nat)) (mod_aux_body)) (q)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (nat.times (((fun (m0:nat.nat) => fun (n0:nat.nat) => nat.match_nat_type (nat.nat) nat.O (fun (q0:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q0 (nat.minus m0 (nat.S n0)) n0)) (nat.leb m0 n0)) (nat.S q)) n) m) (nat.S m)) (y n m)))) ((((sym_eq_mod_aux_body_S) (q)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (nat.times (((fun (m0:nat.nat) => fun (n0:nat.nat) => nat.match_nat_type (nat.nat) nat.O (fun (q0:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q0 (nat.minus m0 (nat.S n0)) n0)) (nat.leb m0 n0)) (nat.S q)) n) m) (nat.S m)) (y n m)))) (((((((nat.sym_eq_match_nat_type_S) (nat.nat)) (nat.O)) (fun (z:nat.nat) => bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux z (nat.minus n (nat.S m)) m)) (nat.leb n m))) (q)) (fun (y:nat.nat) => logic.eq (nat.nat) n (nat.plus (nat.times y (nat.S m)) (bool.match_bool_type (nat.nat) n (mod_aux q (nat.minus n (nat.S m)) m) (nat.leb n m))))) ((((((nat.leb_elim) (n)) (m)) (fun (__:bool.bool) => logic.eq (nat.nat) n (nat.plus (nat.times (bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q (nat.minus n (nat.S m)) m)) __) (nat.S m)) (bool.match_bool_type (nat.nat) n (mod_aux q (nat.minus n (nat.S m)) m) __)))) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (nat.O)) (nat.S (div_aux q (nat.minus n (nat.S m)) m))) (fun (x:nat.nat) => (nat.le n m) -> logic.eq (nat.nat) n (nat.plus (nat.times x (nat.S m)) (bool.match_bool_type (nat.nat) n (mod_aux q (nat.minus n (nat.S m)) m) bool.true)))) ((((nat.sym_eq_times) (nat.O)) (fun (y:(nat.nat -> nat.nat)) => (nat.le n m) -> logic.eq (nat.nat) n (nat.plus (y (nat.S m)) (bool.match_bool_type (nat.nat) n (mod_aux q (nat.minus n (nat.S m)) m) bool.true)))) (((((nat.sym_eq_filter_nat_type_O) (nat.nat -> nat.nat)) (nat.times_body)) (fun (y:(nat.nat -> nat.nat)) => (nat.le n m) -> logic.eq (nat.nat) n (nat.plus (y (nat.S m)) (bool.match_bool_type (nat.nat) n (mod_aux q (nat.minus n (nat.S m)) m) bool.true)))) (((nat.sym_eq_times_body_O) (fun (y:(nat.nat -> nat.nat)) => (nat.le n m) -> logic.eq (nat.nat) n (nat.plus (y (nat.S m)) (bool.match_bool_type (nat.nat) n (mod_aux q (nat.minus n (nat.S m)) m) bool.true)))) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (n)) (mod_aux q (nat.minus n (nat.S m)) m)) (fun (y:nat.nat) => (nat.le n m) -> logic.eq (nat.nat) n (nat.plus nat.O y))) ((((nat.sym_eq_plus) (nat.O)) (fun (y:(nat.nat -> nat.nat)) => (nat.le n m) -> logic.eq (nat.nat) n (y n))) (((((nat.sym_eq_filter_nat_type_O) (nat.nat -> nat.nat)) (nat.plus_body)) (fun (y:(nat.nat -> nat.nat)) => (nat.le n m) -> logic.eq (nat.nat) n (y n))) (((nat.sym_eq_plus_body_O) (fun (y:(nat.nat -> nat.nat)) => (nat.le n m) -> logic.eq (nat.nat) n (y n))) (fun (lenm:nat.le n m) => (((logic.refl) (nat.nat)) (n)))))))))))) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (n)) (mod_aux q (nat.minus n (nat.S m)) m)) (fun (x:nat.nat) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (nat.plus (nat.times (bool.match_bool_type (nat.nat) nat.O (nat.S (div_aux q (nat.minus n (nat.S m)) m)) bool.false) (nat.S m)) x))) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (nat.O)) (nat.S (div_aux q (nat.minus n (nat.S m)) m))) (fun (y:nat.nat) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (nat.plus (nat.times y (nat.S m)) (mod_aux q (nat.minus n (nat.S m)) m)))) ((((nat.sym_eq_times) (nat.S (div_aux q (nat.minus n (nat.S m)) m))) (fun (y:(nat.nat -> nat.nat)) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (nat.plus (y (nat.S m)) (mod_aux q (nat.minus n (nat.S m)) m)))) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat)) (nat.times_body)) (div_aux q (nat.minus n (nat.S m)) m)) (fun (y:(nat.nat -> nat.nat)) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (nat.plus (y (nat.S m)) (mod_aux q (nat.minus n (nat.S m)) m)))) ((((nat.sym_eq_times_body_S) (div_aux q (nat.minus n (nat.S m)) m)) (fun (y:(nat.nat -> nat.nat)) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (nat.plus (y (nat.S m)) (mod_aux q (nat.minus n (nat.S m)) m)))) ((((nat.sym_eq_plus) (nat.S m)) (fun (y:(nat.nat -> nat.nat)) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (nat.plus (y (nat.times (div_aux q (nat.minus n (nat.S m)) m) (nat.S m))) (mod_aux q (nat.minus n (nat.S m)) m)))) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat)) (nat.plus_body)) (m)) (fun (y:(nat.nat -> nat.nat)) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (nat.plus (y (nat.times (div_aux q (nat.minus n (nat.S m)) m) (nat.S m))) (mod_aux q (nat.minus n (nat.S m)) m)))) ((((nat.sym_eq_plus_body_S) (m)) (fun (y:(nat.nat -> nat.nat)) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (nat.plus (y (nat.times (div_aux q (nat.minus n (nat.S m)) m) (nat.S m))) (mod_aux q (nat.minus n (nat.S m)) m)))) ((((nat.sym_eq_plus) (nat.S (nat.plus m (nat.times (div_aux q (nat.minus n (nat.S m)) m) (nat.S m))))) (fun (y:(nat.nat -> nat.nat)) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (y (mod_aux q (nat.minus n (nat.S m)) m)))) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat)) (nat.plus_body)) (nat.plus m (nat.times (div_aux q (nat.minus n (nat.S m)) m) (nat.S m)))) (fun (y:(nat.nat -> nat.nat)) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (y (mod_aux q (nat.minus n (nat.S m)) m)))) ((((nat.sym_eq_plus_body_S) (nat.plus m (nat.times (div_aux q (nat.minus n (nat.S m)) m) (nat.S m)))) (fun (y:(nat.nat -> nat.nat)) => (connectives.Not (nat.le n m)) -> logic.eq (nat.nat) n (y (mod_aux q (nat.minus n (nat.S m)) m)))) (fun (lenm:connectives.Not (nat.le n m)) => (((((((logic.eq_ind_r) (nat.nat)) (nat.plus m (nat.plus (nat.times (div_aux q (nat.minus n (nat.S m)) m) (nat.S m)) (mod_aux q (nat.minus n (nat.S m)) m)))) (fun (x:nat.nat) => logic.eq (nat.nat) n (nat.S x))) (((((((logic.eq_ind) (nat.nat)) (nat.minus n (nat.S m))) (fun (x_1:nat.nat) => logic.eq (nat.nat) n (nat.S (nat.plus m x_1)))) (((((logic.eq_coerc) (logic.eq (nat.nat) n (nat.plus (nat.minus n (nat.S m)) (nat.S m)))) (logic.eq (nat.nat) n (nat.S (nat.plus m (nat.minus n (nat.S m)))))) ((((nat.plus_minus_m_m) (n)) (nat.S m)) ((((nat.not_le_to_lt) (n)) (m)) (lenm)))) (((((((logic.rewrite_r) (nat.nat)) (nat.pred (nat.minus n m))) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n (nat.plus __ (nat.S m))) (logic.eq (nat.nat) n (nat.S (nat.plus m (nat.minus n (nat.S m))))))) (((((((logic.rewrite_r) (nat.nat)) (nat.pred (nat.minus n m))) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n (nat.plus (nat.pred (nat.minus n m)) (nat.S m))) (logic.eq (nat.nat) n (nat.S (nat.plus m __))))) (((((((logic.rewrite_r) (nat.nat)) (nat.plus m (nat.S (nat.pred (nat.minus n m))))) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n (nat.plus (nat.pred (nat.minus n m)) (nat.S m))) (logic.eq (nat.nat) n __))) (((((((logic.rewrite_r) (nat.nat)) (nat.plus m (nat.S (nat.pred (nat.minus n m))))) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n __) (logic.eq (nat.nat) n (nat.plus m (nat.S (nat.pred (nat.minus n m))))))) (((logic.refl) (Prop)) (logic.eq (nat.nat) n (nat.plus m (nat.S (nat.pred (nat.minus n m))))))) (nat.plus (nat.pred (nat.minus n m)) (nat.S m))) (((((((logic.rewrite_l) (nat.nat)) (nat.S (nat.plus (nat.pred (nat.minus n m)) m))) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.plus m (nat.S (nat.pred (nat.minus n m)))))) (((((((logic.rewrite_l) (nat.nat)) (nat.plus m (nat.pred (nat.minus n m)))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.S __) (nat.plus m (nat.S (nat.pred (nat.minus n m)))))) (((nat.plus_n_Sm) (m)) (nat.pred (nat.minus n m)))) (nat.plus (nat.pred (nat.minus n m)) m)) (((nat.commutative_plus) (m)) (nat.pred (nat.minus n m))))) (nat.plus (nat.pred (nat.minus n m)) (nat.S m))) (((nat.plus_n_Sm) (nat.pred (nat.minus n m))) (m))))) (nat.S (nat.plus m (nat.pred (nat.minus n m))))) (((nat.plus_n_Sm) (m)) (nat.pred (nat.minus n m))))) (nat.minus n (nat.S m))) (((nat.eq_minus_S_pred) (n)) (m)))) (nat.minus n (nat.S m))) (((nat.eq_minus_S_pred) (n)) (m))))) (nat.plus (nat.times (div_aux q (nat.minus n (nat.S m)) m) (nat.S m)) (mod_aux q (nat.minus n (nat.S m)) m))) (((Hind) (nat.minus n (nat.S m))) (m)))) (nat.plus (nat.plus m (nat.times (div_aux q (nat.minus n (nat.S m)) m) (nat.S m))) (mod_aux q (nat.minus n (nat.S m)) m))) ((((nat.associative_plus) (m)) (nat.times (div_aux q (nat.minus n (nat.S m)) m) (nat.S m))) (mod_aux q (nat.minus n (nat.S m)) m)))))))))))))))))))))))))) (p).
Definition div_mod : forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) n (nat.plus (nat.times (div n m) m) (mod n m)) := fun (n:nat.nat) => fun (m:nat.nat) => ((((nat.match_nat_prop) (fun (__:nat.nat) => logic.eq (nat.nat) n (nat.plus (nat.times (div n __) __) (mod n __)))) ((((nat.sym_eq_times) (div n nat.O)) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (y nat.O) (mod n nat.O)))) ((((((nat.sym_eq_match_nat_type_O) (nat.nat)) (nat.S n)) (fun (p:nat.nat) => div_aux n n p)) (fun (y:nat.nat) => logic.eq (nat.nat) n (nat.plus (nat.filter_nat_type (nat.nat -> nat.nat) nat.times_body y nat.O) (nat.match_nat_type (nat.nat) n (fun (p:nat.nat) => mod_aux n n p) nat.O)))) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat)) (nat.times_body)) (n)) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (y nat.O) (mod n nat.O)))) ((((nat.sym_eq_times_body_S) (n)) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (y nat.O) (mod n nat.O)))) ((((((nat.sym_eq_match_nat_type_O) (nat.nat)) (n)) (fun (p:nat.nat) => mod_aux n n p)) (fun (y:nat.nat) => logic.eq (nat.nat) n (nat.plus (nat.plus nat.O (nat.times n nat.O)) y))) ((((nat.sym_eq_plus) (nat.O)) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (y (nat.times n nat.O)) n))) (((((nat.sym_eq_filter_nat_type_O) (nat.nat -> nat.nat)) (nat.plus_body)) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (y (nat.times n nat.O)) n))) (((nat.sym_eq_plus_body_O) (fun (y:(nat.nat -> nat.nat)) => logic.eq (nat.nat) n (nat.plus (y (nat.times n nat.O)) n))) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) n (nat.plus __ n))) (((((((logic.rewrite_r) (nat.nat)) (nat.plus n nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) n __)) (((((((logic.rewrite_l) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (nat.nat) n __)) (((logic.refl) (nat.nat)) (n))) (nat.plus n nat.O)) ((nat.plus_n_O) (n)))) (nat.plus nat.O n)) (((nat.commutative_plus) (nat.O)) (n)))) (nat.times n nat.O)) ((nat.times_n_O) (n)))))))))))) (fun (auto:nat.nat) => ((((((nat.sym_eq_match_nat_type_S) (nat.nat)) (nat.S n)) (fun (p:nat.nat) => div_aux n n p)) (auto)) (fun (y:nat.nat) => logic.eq (nat.nat) n (nat.plus (nat.times y (nat.S auto)) (nat.match_nat_type (nat.nat) n (fun (p:nat.nat) => mod_aux n n p) (nat.S auto))))) (((((((nat.sym_eq_match_nat_type_S) (nat.nat)) (n)) (fun (p:nat.nat) => mod_aux n n p)) (auto)) (fun (y:nat.nat) => logic.eq (nat.nat) n (nat.plus (nat.times (div_aux n n auto) (nat.S auto)) y))) (((((((logic.rewrite_r) (nat.nat)) (nat.plus (nat.times (div_aux n n auto) (nat.S auto)) (mod_aux n n auto))) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.plus (nat.times (div_aux n n auto) (nat.S auto)) (mod_aux n n auto)))) (((logic.refl) (nat.nat)) (nat.plus (nat.times (div_aux n n auto) (nat.S auto)) (mod_aux n n auto)))) (n)) ((((div_aux_mod_aux) (n)) (n)) (auto)))))) (m).
